parameter num_remotes;

set option public.Global_database_id = 0;
set option public.delete_old_logs = 'ON';

create table Admin (
  admin_id integer default global autoincrement(100000) primary key,
  data varchar(30),
  last_modified timestamp default timestamp
);

create table Admin_del (
  pk integer default autoincrement primary key,
  admin_id integer,
  del_time timestamp default current timestamp
);

create trigger bd_admin before delete on Admin
referencing old as pr for each row
begin
  insert into Admin_del(admin_id) values ( pr.admin_id );
end;

call ml_add_table_script( 'v1', 'Admin', 'upload_insert', 'insert into Admin values (?,?,DEFAULT)' );
call ml_add_table_script( 'v1', 'Admin', 'upload_update', 'update Admin set data = ? where admin_id = ?' );
call ml_add_table_script( 'v1', 'Admin', 'upload_delete', 'delete from Admin where admin_id = ?' );
call ml_add_table_script( 'v1', 'Admin', 'download_cursor', 'select admin_id, data from Admin where last_modified >= ?' );
call ml_add_table_script( 'v1', 'Admin', 'download_delete_cursor', 'select admin_id from Admin_del where del_time >= ?' );

call ml_add_java_connection_script( 'v1', 'handle_error', 'Example.handleError' );
call ml_add_java_connection_script( 'v1', 'end_connection', 'Example.endConnection' );
	

CREATE PROCEDURE rep_data(IN iter INTEGER DEFAULT 1, IN do_commit INTEGER DEFAULT 0) 
BEGIN
  DECLARE j INTEGER;
  
  SET j = 0;
  WHILE j < iter LOOP
    INSERT INTO Admin(data) VALUES (CAST(RAND()*20 + 1 AS CHAR(10)));
    SET j = j + 1;
    IF do_commit = 1 THEN
      COMMIT;
    END IF;
  END LOOP;
  COMMIT;
END;

call rep_data( 5 );
commit;

create table mlLog (
  pkey    bigint default autoincrement primary key,
  msgType integer,
  msgUser varchar(128),
  msgText long varchar,
  msgTime timestamp default current timestamp
);
