@echo off

rem 
rem To change the number of remote users, change the num variable to the 
rem desired amount.
rem
set num=1

rem 
rem Clean up anything from previous runs
rem 

dbmlstop -w
start /wait dbstop -y -c "eng=cons;dbn=cons;uid=dba;pwd=sql"
dberase -y cons\cons.db
for /L %%i in (1,1,%num%) do dberase -y rem%%i\rem%%i.db

erase /Q /F cons
for /L %%i in (1,1,%num%) do erase /Q /F rem%%i

rmdir cons
for /L %%i in (1,1,%num%) do rmdir rem%%i

attrib -r *.*
attrib +r *.bat
attrib +r *.sql
attrib +r *.java
attrib +r *.class
attrib +r readme.txt
echo y|del *.*
attrib -r *.bat
attrib -r *.sql
attrib -r *.java
attrib -r *.class
attrib -r readme.txt

rem
rem Define the DSN that MobiLink will use
rem 
dbdsn -y -wu cons_90 -c "eng=cons;dbn=cons;uid=dba;pwd=sql"

rem
rem Create the directories to store the consolidated 
rem and remote database(s)
rem
mkdir cons
for /L %%i in (1,1,%num%) do mkdir rem%%i

rem
rem Create a empty database so we don't have to initialize
rem new databases every time we run the batch file
rem
if not exist tempDB mkdir tempDB
if not exist tempDB\cons.db dbinit -p 4096 tempDB\cons.db -n

rem
rem Create the consolidated and remote databases
rem
copy tempDB\cons.db cons\cons.db
for /L %%i in (1,1,%num%) do copy tempDB\cons.db rem%%i\rem%%i.db
dblog -t cons.log cons\cons.db
for /L %%i in (1,1,%num%) do dblog -t rem%%i.log rem%%i\rem%%i.db

rem 
rem Define the schema for the consolidated database and
rem autostart a database server
rem
start /wait dbisqlc -Q -c "uid=dba;pwd=sql;eng=cons;dbf=cons\cons.db;autostop=no;start=dbsrv9 -gd all -x none" read cons.sql %num%

rem
rem Define the schema for the remote databases and mount the 
rem remote databases on the same engine where the consolidated
rem database is running 
rem
for /L %%i in (1,1,%num%) do dbisqlc -Q -c "uid=dba;pwd=sql;eng=cons;dbf=rem%%i\rem%%i.db;autostop=no" read rem.sql %%i

rem 
rem Define the MobiLink User(s) in the consolidated database
rem
for /L %%i in (1,1,%num%) do dbmluser -c "dsn=cons_90" -u rem%%i -p sql

rem
rem To Compile the Java class yourself, you would use the following 
rem command line 
rem
rem %JDK13_DIR%\bin\javac -classpath %ASANY9%\java\mlscript.jar Example.java

rem 
rem Start the MobiLink Server and define a start class
rem
start dbmlsrv9 -v+ -ot mlsrv.txt -c "dsn=cons_90" -sl java(-DMLStartClasses=Example -cp .)
echo === 
echo === Press any key when the MobiLink Server 
echo === is ready to accept request.
echo ===
pause

rem
rem Perform the inital synchronization
rem
for /L %%i in (1,1,%num%) do start /wait dbmlsync -c "eng=cons;dbn=rem%%i;uid=dba;pwd=sql" -mp sql -v+ -o rem%%i.txt -k

echo === 
echo === We will now force a primary key violation to test that rows are 
echo === added to the mlLog table when warnings and errors are posted
echo === to the MobiLink output log
echo ===
pause

start /wait dbisqlc -Q -c "eng=cons;dbn=cons;uid=dba;pwd=sql" insert into Admin values ( 10, 'cons', DEFAULT )
start /wait dbisqlc -Q -c "eng=cons;dbn=rem1;uid=dba;pwd=sql" insert into Admin values ( 10, 'rem1' )
start /wait dbmlsync -c "eng=cons;dbn=rem1;uid=dba;pwd=sql" -mp sql -v+ -o rem1.txt -k

echo === 
echo === The contents of the mlLog table 
echo ===
dbisql -nogui -c "eng=cons;dbn=cons;uid=dba;pwd=sql" select * from mlLog
